## timescaledb 2.15.2+dfsg

=== sql/CMakeLists.txt ===
set(INSTALL_FILE ${PROJECT_NAME}--${PROJECT_VERSION_MOD}.sql)

include(ScriptFiles)

# These files represent the modifications that happen in each version, excluding
# new objects or updates to functions. We use them to build a path (update
# script) from every historical version to the current version. Note that not
# all of these files may exist on disk, in case they would have no contents.
# There still needs to be an entry here to build an update script for that
# version. Thus, for every new release, an entry should be added here.
set(MOD_FILES
    updates/2.1.0--2.1.1.sql
    updates/2.1.1--2.2.0.sql
    updates/2.2.0--2.2.1.sql
    updates/2.2.1--2.3.0.sql
    updates/2.3.0--2.3.1.sql
    updates/2.3.1--2.4.0.sql
    updates/2.4.0--2.4.1.sql
    updates/2.4.1--2.4.2.sql
    updates/2.4.2--2.5.0.sql
    updates/2.5.0--2.5.1.sql
    updates/2.5.1--2.5.2.sql
    updates/2.5.2--2.6.0.sql
    updates/2.6.0--2.6.1.sql
    updates/2.6.1--2.7.0.sql
    updates/2.7.0--2.7.1.sql
    updates/2.7.1--2.7.2.sql
    updates/2.7.2--2.8.0.sql
    updates/2.8.0--2.8.1.sql
    updates/2.8.1--2.9.0.sql
    updates/2.9.0--2.9.1.sql
    updates/2.9.1--2.9.2.sql
    updates/2.9.2--2.9.3.sql
    updates/2.9.3--2.10.0.sql
    updates/2.10.0--2.10.1.sql
    updates/2.10.1--2.10.2.sql
    updates/2.10.2--2.10.3.sql
    updates/2.10.3--2.11.0.sql
    updates/2.11.0--2.11.1.sql
    updates/2.11.1--2.11.2.sql
    updates/2.11.2--2.12.0.sql
    updates/2.12.0--2.12.1.sql
    updates/2.12.1--2.12.2.sql
    updates/2.12.2--2.13.0.sql
    updates/2.13.0--2.13.1.sql
    updates/2.13.1--2.14.0.sql
    updates/2.14.0--2.14.1.sql
    updates/2.14.1--2.14.2.sql
    updates/2.14.2--2.15.0.sql
    updates/2.15.0--2.15.1.sql
    updates/2.15.1--2.15.2.sql)

# The downgrade file to generate a downgrade script for the current version, as
# specified in version.config
set(CURRENT_REV_FILE 2.15.2--2.15.1.sql)
# Files for generating old downgrade scripts. This should only include files for
# downgrade from one version to its previous version since we do not support
# skipping versions when downgrading.
set(OLD_REV_FILES
    2.3.1--2.3.0.sql
    2.4.0--2.3.1.sql
    2.4.1--2.4.0.sql
    2.4.2--2.4.1.sql
    2.5.0--2.4.2.sql
    2.5.1--2.5.0.sql
    2.5.2--2.5.1.sql
    2.6.0--2.5.2.sql
    2.6.1--2.6.0.sql
    2.7.0--2.6.1.sql
    2.7.1--2.7.0.sql
    2.7.2--2.7.1.sql
    2.8.0--2.7.2.sql
    2.8.1--2.8.0.sql
    2.9.0--2.8.1.sql
    2.9.1--2.9.0.sql
    2.9.2--2.9.1.sql
    2.9.3--2.9.2.sql
    2.10.0--2.9.3.sql
    2.10.1--2.10.0.sql
    2.10.2--2.10.1.sql
    2.10.3--2.10.2.sql
    2.11.0--2.10.3.sql
    2.11.1--2.11.0.sql
    2.11.2--2.11.1.sql
    2.12.0--2.11.2.sql
    2.12.1--2.12.0.sql
    2.12.2--2.12.1.sql
    2.13.0--2.12.2.sql
    2.13.1--2.13.0.sql
    2.14.0--2.13.1.sql
    2.14.1--2.14.0.sql
    2.14.2--2.14.1.sql
    2.15.0--2.14.2.sql
    2.15.1--2.15.0.sql
    2.15.2--2.15.1.sql)

set(MODULE_PATHNAME "$libdir/timescaledb-${PROJECT_VERSION_MOD}")
set(LOADER_PATHNAME "$libdir/timescaledb")

set(TS_MODULE_PATHNAME
    ${MODULE_PATHNAME}
    PARENT_SCOPE)

set(TSL_MODULE_PATHNAME
    "$libdir/timescaledb-tsl-${PROJECT_VERSION_MOD}"
    PARENT_SCOPE)

if(NOT GENERATE_DOWNGRADE_SCRIPT)
  message(
    STATUS "Not generating downgrade script: downgrade generation disabled.")
elseif(NOT GIT_FOUND)
  message(STATUS "Not generating downgrade script: Git not available.")
else()
  generate_downgrade_script(
    SOURCE_VERSION
    ${PROJECT_VERSION_MOD}
    TARGET_VERSION
    ${DOWNGRADE_TO_VERSION}
    INPUT_DIRECTORY
    ${CMAKE_CURRENT_SOURCE_DIR}/updates
    FILES
    ${CURRENT_REV_FILE})
  if(GENERATE_OLD_DOWNGRADE_SCRIPTS)
    foreach(_downgrade_file ${OLD_REV_FILES})
      if(${_downgrade_file} MATCHES
         "([0-9]+\\.[0-9]+\\.*[0-9]*)--([0-9]+\\.[0-9]+\\.*[0-9]*).sql")
        set(_source_version ${CMAKE_MATCH_1})
        set(_target_version ${CMAKE_MATCH_2})
        generate_downgrade_script(
          SOURCE_VERSION
          ${_source_version}
          TARGET_VERSION
          ${_target_version}
          INPUT_DIRECTORY
          ${CMAKE_CURRENT_SOURCE_DIR}/updates
          FILES
          ${_downgrade_file})
      else()
        message(FATAL_ERROR "${_downgrade_file} is not a downgrade file")
      endif()
    endforeach()
  endif()
endif()

# Function to replace @MODULE_PATHNAME@ in source files, producing an output
# file in the build dir
function(version_files SRC_FILE_LIST OUTPUT_FILE_LIST)
  set(result "")
  foreach(unversioned_file ${SRC_FILE_LIST})
    set(versioned_file ${unversioned_file})
    list(APPEND result ${CMAKE_CURRENT_BINARY_DIR}/${versioned_file})
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${unversioned_file})
      configure_file(${unversioned_file} ${versioned_file} @ONLY)
    endif()
  endforeach(unversioned_file)
  set(${OUTPUT_FILE_LIST}
      "${result}"
      PARENT_SCOPE)
endfunction()

# Function to replace @VARIABLE@ in source files, producing an output file in
# the build dir.  Unlike the previous function we need to build a versioned file
# for every version we create an update script for.
function(version_check_file SRC_FILE_LIST OUTPUT_FILE_LIST)
  set(result "")
  foreach(unversioned_file ${SRC_FILE_LIST})
    set(versioned_file ${unversioned_file}-${START_VERSION})
    list(APPEND result ${CMAKE_CURRENT_BINARY_DIR}/${versioned_file})
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${unversioned_file})
      configure_file(${unversioned_file} ${versioned_file} @ONLY)
    endif()
  endforeach(unversioned_file)
  set(${OUTPUT_FILE_LIST}
      "${result}"
      PARENT_SCOPE)
endfunction()

# Create versioned files (replacing MODULE_PATHNAME) in the build directory of
# all our source files
version_files("${PRE_UPDATE_FILES}" PRE_UPDATE_FILES_VERSIONED)
version_files("${POST_UPDATE_FILES}" POST_UPDATE_FILES_VERSIONED)
version_files("${PRE_INSTALL_SOURCE_FILES}" PRE_INSTALL_SOURCE_FILES_VERSIONED)
version_files("${PRE_INSTALL_FUNCTION_FILES}"
              PRE_INSTALL_FUNCTION_FILES_VERSIONED)
version_files("${SOURCE_FILES}" SOURCE_FILES_VERSIONED)
version_files("${MOD_FILES}" MOD_FILES_VERSIONED)
version_files("updates/latest-dev.sql" LASTEST_MOD_VERSIONED)
version_files("notice.sql" NOTICE_FILE)

# Function to concatenate all files in SRC_FILE_LIST into file OUTPUT_FILE
function(cat_files SRC_FILE_LIST OUTPUT_FILE)
  if(WIN32)
    set("SRC_ARG" "-DSRC_FILE_LIST=${SRC_FILE_LIST}")
  else()
    set("SRC_ARG" "'-DSRC_FILE_LIST=${SRC_FILE_LIST}'")
  endif()
  add_custom_command(
    OUTPUT ${OUTPUT_FILE}
    DEPENDS ${SRC_FILE_LIST}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMAND ${CMAKE_COMMAND} "${SRC_ARG}" "-DOUTPUT_FILE=${OUTPUT_FILE}" -P
            cat.cmake
    COMMENT "Generating ${OUTPUT_FILE}")
endfunction()

# Concatenate all files in SRC_FILE_LIST into file OUTPUT_FILE Additionally
# strips out `OR REPLACE` from the generated file as this would allow a
# privilege escalation attack when present in the CREATE script
function(cat_create_files SRC_FILE_LIST OUTPUT_FILE)
  if(WIN32)
    set("SRC_ARG" "-DSRC_FILE_LIST=${SRC_FILE_LIST}")
  else()
    set("SRC_ARG" "'-DSRC_FILE_LIST=${SRC_FILE_LIST}'")
  endif()
  if(WIN32)
    add_custom_command(
      OUTPUT ${OUTPUT_FILE}
      DEPENDS ${SRC_FILE_LIST}
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMAND ${CMAKE_COMMAND} "${SRC_ARG}" "-DOUTPUT_FILE=${OUTPUT_FILE}"
              "-DSTRIP_REPLACE=ON" -P cat.cmake
      COMMENT "Generating ${OUTPUT_FILE}")
  else()
    add_custom_command(
      OUTPUT ${OUTPUT_FILE}
      DEPENDS ${SRC_FILE_LIST}
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMAND ${CMAKE_COMMAND} "'-DSRC_FILE_LIST=${SRC_FILE_LIST}'"
              "-DOUTPUT_FILE=${OUTPUT_FILE}" "-DSTRIP_REPLACE=ON" -P cat.cmake
      COMMENT "Generating ${OUTPUT_FILE}")
  endif()
endfunction()

# Generate the extension file used with CREATE EXTENSION
cat_create_files(
  "${PRE_INSTALL_SOURCE_FILES_VERSIONED};${SOURCE_FILES_VERSIONED};${NOTICE_FILE}"
  ${CMAKE_CURRENT_BINARY_DIR}/${INSTALL_FILE})
add_custom_target(sqlfile ALL
                  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${INSTALL_FILE})

# Generate the update files used with ALTER EXTENSION <name> UPDATE
set(MOD_FILE_REGEX
    "([0-9]+\\.[0-9]+\\.*[0-9]+[-a-z0-9]*)--([0-9]+\\.[0-9]+\\.*[0-9]+[-a-z0-9]*).sql"
)

# We'd like to process the updates in reverse (descending) order
if(EXISTS
   "${CMAKE_CURRENT_SOURCE_DIR}/updates/${UPDATE_FROM_VERSION}--${PROJECT_VERSION_MOD}.sql"
)
  set(MOD_FILES_LIST ${MOD_FILES_VERSIONED})
else()
  set(MOD_FILES_LIST
      "${MOD_FILES_VERSIONED};updates/${UPDATE_FROM_VERSION}--${PROJECT_VERSION_MOD}.sql"
  )
endif()

list(REVERSE MOD_FILES_LIST)

# Variable that will hold the list of update scripts from every previous version
# to the current version
set(UPDATE_SCRIPTS "")

# A list of current modfiles. We append to this list for every previous version
# that moves us further away from the current version, thus making the update
# path longer as we move back in history
set(CURR_MOD_FILES "${LASTEST_MOD_VERSIONED}")

# Now loop through the modfiles and generate the update files
foreach(transition_mod_file ${MOD_FILES_LIST})

  if(NOT (${transition_mod_file} MATCHES ${MOD_FILE_REGEX}))
    message(FATAL_ERROR "Cannot parse update file name ${mod_file}")
  endif()

  set(START_VERSION ${CMAKE_MATCH_1})
  set(END_VERSION ${CMAKE_MATCH_2})
  set(PRE_FILES ${PRE_UPDATE_FILES_VERSIONED})
  set(POST_FILES_PROCESSED ${POST_UPDATE_FILES_VERSIONED}.processed)
  cat_files(
    "${SET_POST_UPDATE_STAGE};${POST_UPDATE_FILES_VERSIONED};${UNSET_UPDATE_STAGE}"
    ${POST_FILES_PROCESSED})
  # Check for version-specific update code with fixes
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/updates/${START_VERSION}.sql)
    version_files("updates/${START_VERSION}.sql" ORIGIN_MOD_FILE)
    list(APPEND PRE_FILES ${ORIGIN_MOD_FILE})
  endif()

  version_check_file("updates/version_check.sql" VERSION_CHECK_VERSIONED)
  list(PREPEND PRE_FILES ${VERSION_CHECK_VERSIONED})

  # There might not have been any changes in the modfile, in which case the
  # modfile need not be present
  if(EXISTS ${transition_mod_file})
    # Prepend the modfile as we are moving through the versions in descending
    # order
    list(INSERT CURR_MOD_FILES 0 ${transition_mod_file})
  endif()

  set(UPDATE_SCRIPT
      ${CMAKE_CURRENT_BINARY_DIR}/timescaledb--${START_VERSION}--${PROJECT_VERSION_MOD}.sql
  )
  list(APPEND UPDATE_SCRIPTS ${UPDATE_SCRIPT})
  if(CURR_MOD_FILES)
    cat_files(
      "${PRE_FILES};${CURR_MOD_FILES};${PRE_INSTALL_FUNCTION_FILES_VERSIONED};${SOURCE_FILES_VERSIONED};${POST_FILES_PROCESSED}"
      ${UPDATE_SCRIPT})
  else()
    cat_files(
      "${PRE_FILES};${PRE_INSTALL_FUNCTION_FILES_VERSIONED};${SOURCE_FILES_VERSIONED};${POST_FILES_PROCESSED}"
      ${UPDATE_SCRIPT})
  endif()

endforeach(transition_mod_file)

add_custom_target(sqlupdatescripts ALL DEPENDS ${UPDATE_SCRIPTS})

# Install target for the extension file and update scripts
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${INSTALL_FILE} ${UPDATE_SCRIPTS}
        DESTINATION "${PG_SHAREDIR}/extension")

=== src/ts_catalog/CMakeLists.txt ===
set(SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/array_utils.c
    ${CMAKE_CURRENT_SOURCE_DIR}/catalog.c
    ${CMAKE_CURRENT_SOURCE_DIR}/compression_chunk_size.c
    ${CMAKE_CURRENT_SOURCE_DIR}/compression_settings.c
    ${CMAKE_CURRENT_SOURCE_DIR}/continuous_agg.c
    ${CMAKE_CURRENT_SOURCE_DIR}/continuous_aggs_watermark.c
    ${CMAKE_CURRENT_SOURCE_DIR}/metadata.c
    ${CMAKE_CURRENT_SOURCE_DIR}/tablespace.c)
target_sources(${PROJECT_NAME} PRIVATE ${SOURCES})

=== test/sql/CMakeLists.txt ===
include(GenerateTestSchedule)

set(TEST_FILES
    agg_bookends.sql
    alter.sql
    alternate_users.sql
    baserel_cache.sql
    catalog_corruption.sql
    chunks.sql
    chunk_adaptive.sql
    chunk_utils.sql
    create_chunks.sql
    create_hypertable.sql
    create_table.sql
    constraint.sql
    copy.sql
    copy_where.sql
    ddl_errors.sql
    debug_utils.sql
    drop_extension.sql
    drop_hypertable.sql
    drop_owned.sql
    drop_rename_hypertable.sql
    drop_schema.sql
    dump_meta.sql
    extension_scripts.sql
    generated_as_identity.sql
    grant_hypertable.sql
    hash.sql
    index.sql
    information_views.sql
    insert_many.sql
    insert_single.sql
    insert_returning.sql
    lateral.sql
    null_exclusion.sql
    partition.sql
    partitioning.sql
    pg_join.sql
    plain.sql
    plan_hypertable_inline.sql
    relocate_extension.sql
    reloptions.sql
    repair.sql
    size_utils.sql
    sort_optimization.sql
    sql_query.sql
    tableam.sql
    tablespace.sql
    triggers.sql
    truncate.sql
    upsert.sql
    util.sql
    vacuum.sql
    version.sql
    license.sql)

set(TEST_TEMPLATES
    append.sql.in
    cluster.sql.in
    cursor.sql.in
    ddl.sql.in
    delete.sql.in
    histogram_test.sql.in
    insert.sql.in
    plan_hashagg.sql.in
    rowsecurity.sql.in
    update.sql.in
    parallel.sql.in
    partitionwise.sql.in
    plan_expand_hypertable.sql.in
    plan_ordered_append.sql.in
    query.sql.in
    timestamp.sql.in)

# Loader test must distinguish between Apache and TSL builds so we parametrize
# this here
set(LOADER_TEST_FILE loader-${TEST_LICENSE_SUFFIX})
configure_file(loader.sql.in
               ${CMAKE_CURRENT_SOURCE_DIR}/${LOADER_TEST_FILE}.sql)

# tests that fail or are unreliable when run in parallel bgw tests need to run
# first otherwise they are flaky
set(SOLO_TESTS
    alter
    alternate_users
    bgw_launcher
    chunk_utils
    index
    net
    pg_dump_unprivileged
    tablespace
    telemetry)

list(APPEND SOLO_TESTS ${LOADER_TEST_FILE})

if(CMAKE_BUILD_TYPE MATCHES Debug)
  list(
    APPEND
    TEST_FILES
    bgw_launcher.sql
    c_unit_tests.sql
    copy_memory_usage.sql
    metadata.sql
    multi_transaction_index.sql
    net.sql
    pg_dump.sql
    symbol_conflict.sql
    test_tss_callbacks.sql
    test_utils.sql
    ${LOADER_TEST_FILE}.sql)
  if(USE_TELEMETRY)
    list(APPEND TEST_FILES telemetry.sql)
  endif()
endif(CMAKE_BUILD_TYPE MATCHES Debug)

if((${PG_VERSION_MAJOR} GREATER_EQUAL "13"))
  list(APPEND TEST_FILES trusted_extension.sql vacuum_parallel.sql)
endif()

if((${PG_VERSION_MAJOR} GREATER_EQUAL "14"))
  list(APPEND TEST_FILES ddl_extra.sql)
endif()

if((${PG_VERSION_MAJOR} GREATER_EQUAL "15"))
  list(APPEND TEST_FILES merge.sql)
  list(APPEND TEST_TEMPLATES ts_merge.sql.in)
endif()

# pg_dump_unprivileged.sql was fixed by an upstream change to pg_dump in 13.14,
# 14.11, 15.6, and 16.2
if(((${PG_VERSION_MAJOR} EQUAL "13") AND (${PG_VERSION_MINOR} GREATER_EQUAL "14"
                                         ))
   OR ((${PG_VERSION_MAJOR} EQUAL "14") AND (${PG_VERSION_MINOR} GREATER_EQUAL
                                             "11"))
   OR ((${PG_VERSION_MAJOR} EQUAL "15") AND (${PG_VERSION_MINOR} GREATER_EQUAL
                                             "6"))
   OR ((${PG_VERSION_MAJOR} EQUAL "16") AND (${PG_VERSION_MINOR} GREATER_EQUAL
                                             "2")))
  list(APPEND TEST_FILES pg_dump_unprivileged.sql)
endif()

# only test custom type if we are in 64-bit architecture
if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
  list(APPEND TEST_FILES custom_type.sql)
endif()

# Regression tests that vary with PostgreSQL version. Generated test files are
# put in the original source directory since all tests must be in the same
# directory. These files are updated when the template is edited, but not when
# the output file is deleted. If the output is deleted either recreate it
# manually, or rerun cmake on the root dir.
foreach(TEMPLATE_FILE ${TEST_TEMPLATES})
  string(LENGTH ${TEMPLATE_FILE} TEMPLATE_NAME_LEN)
  math(EXPR TEMPLATE_NAME_LEN ${TEMPLATE_NAME_LEN}-7)
  string(SUBSTRING ${TEMPLATE_FILE} 0 ${TEMPLATE_NAME_LEN} TEMPLATE)
  set(TEST_FILE ${TEMPLATE}-${TEST_VERSION_SUFFIX}.sql)
  configure_file(${TEMPLATE_FILE} ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_FILE}
                 @ONLY)
  list(APPEND TEST_FILES ${TEST_FILE})
endforeach(TEMPLATE_FILE)

if(NOT TEST_GROUP_SIZE)
  set(PARALLEL_GROUP_SIZE 20)
else()
  set(PARALLEL_GROUP_SIZE ${TEST_GROUP_SIZE})
endif()

# Generate a test schedule for each configuration.
generate_test_schedule(
  ${TEST_SCHEDULE}
  TEST_FILES
  ${TEST_FILES}
  SOLO
  ${SOLO_TESTS}
  GROUP_SIZE
  ${PARALLEL_GROUP_SIZE})

add_subdirectory(loader)

=== debian/changelog ===
timescaledb (2.15.2+dfsg-1) unstable; urgency=medium

  * Initial release.
  * Remove tsl-licensed files.
  * Disable telemetry.
  * Fix histogram test on arm64.
  * Restrict to little-endian 64-bit architectures.

 -- Christoph Berg <myon@debian.org>  Tue, 11 Jun 2024 08:16:22 +0000

## timescaledb 2.15.3+dfsg

=== debian/changelog ===
timescaledb (2.15.3+dfsg-1) unstable; urgency=medium

  * New upstream version 2.15.3+dfsg.

 -- Christoph Berg <myon@debian.org>  Mon, 15 Jul 2024 13:48:56 +0200

## timescaledb 2.16.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(CheckCCompilerFlag)
include(CheckSymbolExists)
include(GitCommands)
include(GenerateScripts)
include(CMakeDependentOption)

option(APACHE_ONLY "only compile apache code" off)
# This requires all tests to run. This defaults to OFF but can be enabled to
# ensure that no tests are skipped because of missing tools.
option(REQUIRE_ALL_TESTS "Require all tests to run." OFF)
option(USE_OPENSSL "Enable use of OpenSSL if available" ON)
option(SEND_TELEMETRY_DEFAULT "The default value for whether to send telemetry"
       ON)
option(
  USE_TELEMETRY
  "Include telemetry functionality in the build. Disabling will exclude all telemetry code from the build."
  ON)

option(REGRESS_CHECKS "PostgreSQL regress checks through installcheck" ON)
option(
  ENABLE_OPTIMIZER_DEBUG
  "Enable OPTIMIZER_DEBUG when building. Requires Postgres server to be built with OPTIMIZER_DEBUG."
  OFF)
option(ENABLE_DEBUG_UTILS "Enable debug utilities for the extension." ON)

# Option to enable assertions. Note that if we include headers from a PostgreSQL
# build that has assertions enabled, we might inherit that setting without
# explicitly enabling assertions via the ASSERTIONS option defined here. Thus,
# this option is mostly useful to enable assertions when the PostgreSQL we
# compile against has it disabled.
option(ASSERTIONS "Compile with assertion checks (default OFF)" OFF)

# Function to call pg_config and extract values.
function(GET_PG_CONFIG var)
  set(_temp)

  # Only call pg_config if the variable didn't already have a value.
  if(NOT ${var})
    execute_process(
      COMMAND ${PG_CONFIG} ${ARGN}
      OUTPUT_VARIABLE _temp
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()

  # On Windows, fields that are not recorded will be given the value "not
  # recorded", so we translate this into <var>-NOTFOUND to make it undefined.
  #
  # It will then also show as, e.g., "PG_LDFLAGS-NOTFOUND" in any string
  # interpolation, making it obvious that it is an undefined CMake variable.
  if("${_temp}" STREQUAL "not recorded")
    set(_temp ${var}-NOTFOUND)
  endif()

  set(${var}
      ${_temp}
      PARENT_SCOPE)
endfunction()

configure_file("version.config" "version.config" COPYONLY)
file(READ version.config VERSION_CONFIG)

if(VERSION_CONFIG
   MATCHES
   "(^|.*[^a-z])version[\t ]*=[\t ]*([0-9]+\\.[0-9]+\\.*[0-9]*)(-([a-z]+[0-9]*|dev))?.*"
)
  set(VERSION ${CMAKE_MATCH_2})
  set(VERSION_MOD ${CMAKE_MATCH_4}) # This is used in config.h
  if(CMAKE_MATCH_3)
    set(PROJECT_VERSION_MOD ${CMAKE_MATCH_2}${CMAKE_MATCH_3})
  else()
    set(PROJECT_VERSION_MOD ${CMAKE_MATCH_2})
  endif()
endif()

if(VERSION_CONFIG
   MATCHES
   ".*update_from_version[\t ]*=[\t ]*([0-9]+\\.[0-9]+\\.[0-9]+(-[a-z]+[0-9]*)?).*"
)
  set(UPDATE_FROM_VERSION ${CMAKE_MATCH_1})
endif()

if(VERSION_CONFIG
   MATCHES
   ".*downgrade_to_version[\t ]*=[\t ]*([0-9]+\\.[0-9]+\\.[0-9]+(-[a-z]+[0-9]*)?).*"
)
  set(DOWNGRADE_TO_VERSION ${CMAKE_MATCH_1})
endif()

# a hack to avoid change of SQL extschema variable
set(extschema "@extschema@")

# Set project name, version, and language. Language needs to be set for compiler
# checks
project(
  timescaledb
  VERSION ${VERSION}
  LANGUAGES C)

if(NOT CMAKE_BUILD_TYPE)
  # Default to Release builds
  set(CMAKE_BUILD_TYPE
      Release
      CACHE
        STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

set(SUPPORTED_BUILD_TYPES Debug Release RelWithDebInfo MinSizeRel)
if(NOT CMAKE_BUILD_TYPE IN_LIST SUPPORTED_BUILD_TYPES)
  message(
    FATAL_ERROR "Bad CMAKE_BUILD_TYPE. Expected one of ${SUPPORTED_BUILD_TYPES}"
  )
endif()

message(
  STATUS
    "TimescaleDB version ${PROJECT_VERSION_MOD}. Can be updated from version ${UPDATE_FROM_VERSION}"
)
message(STATUS "Build type is ${CMAKE_BUILD_TYPE}")

set(PROJECT_INSTALL_METHOD
    source
    CACHE STRING "Specify what install platform this binary
is built for")
message(STATUS "Install method is '${PROJECT_INSTALL_METHOD}'")

# Build compilation database by default
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Code coverage is optional and OFF by default
option(CODECOVERAGE "Enable code coverage for the build" OFF)
option(EXPERIMENTAL "Skip postgres version compatibility check" OFF)

# Generate downgrade script
option(GENERATE_DOWNGRADE_SCRIPT
       "Generate downgrade script. Defaults to not generate a downgrade script."
       OFF)
cmake_dependent_option(
  GENERATE_OLD_DOWNGRADE_SCRIPTS
  "Generate downgrade scripts for old versions. Requires setting GENERATE_DOWNGRADE_SCRIPT to ON. Defaults to OFF."
  OFF
  "GENERATE_DOWNGRADE_SCRIPT"
  ON)

if(CMAKE_BUILD_TYPE MATCHES Debug)
  # CMAKE_BUILD_TYPE is set at CMake configuration type. But usage of
  # CMAKE_C_FLAGS_DEBUG is determined at build time by running cmake --build .
  # --config Debug (at least on Windows). Therefore, we only set these flags if
  # the configuration-time CMAKE_BUILD_TYPE is set to Debug. Then Debug enabled
  # builds will only happen on Windows if both the configuration- and build-time
  # settings are Debug.
  set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DDEBUG=1 -DTS_DEBUG=1")
endif(CMAKE_BUILD_TYPE MATCHES Debug)

set(SUPPORTED_COMPILERS "GNU" "Clang" "AppleClang" "MSVC")

# Check for a supported compiler
if(NOT CMAKE_C_COMPILER_ID IN_LIST SUPPORTED_COMPILERS)
  message(
    FATAL_ERROR
      "Unsupported compiler ${CMAKE_C_COMPILER_ID}. Supported compilers are: ${SUPPORTED_COMPILERS}"
  )
endif()

# Option to treat warnings as errors when compiling (default on for debug
# builds, off for all other build types)
if(CMAKE_BUILD_TYPE STREQUAL Debug)
  option(WARNINGS_AS_ERRORS "Make compiler warnings into errors (default ON)"
         ON)
else()
  option(WARNINGS_AS_ERRORS "Make compiler warnings into errors (default ON)"
         OFF)
endif()

if(WARNINGS_AS_ERRORS)
  if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang|AppleClang")
    add_compile_options(-Werror)
  elseif(CMAKE_C_COMPILER_ID MATCHES "MSVC")
    add_compile_options(/WX)
  endif()
endif(WARNINGS_AS_ERRORS)

if(CMAKE_C_COMPILER_ID MATCHES "GNU|AppleClang|Clang")
  # These two flags generate too many errors currently, but we probably want
  # these optimizations enabled.
  #
  # -fdelete-null-pointer-checks -Wnull-dereference

  # This flag avoid some subtle bugs related to standard conversions, but
  # currently does not compile because we are using too many implicit
  # conversions that potentially lose precision.
  #
  # -Wconversions

  # These flags are supported on all compilers.
  add_compile_options(
    -Wempty-body
    -Wvla
    -Wall
    -Wextra
    # The SQL function arguments macro PG_FUNCTION_ARGS often inroduces unused
    # arguments.
    -Wno-unused-parameter
    -Wundef
    -Wmissing-prototypes
    -Wpointer-arith
    -Werror=vla
    -Wendif-labels
    -fno-strict-aliasing
    -fno-omit-frame-pointer)

  # These flags are just supported on some of the compilers, so we check them
  # before adding them.
  check_c_compiler_flag(-Wno-unused-command-line-argument
                        CC_SUPPORTS_NO_UNUSED_CLI_ARG)
  if(CC_SUPPORTS_NO_UNUSED_CLI_ARG)
    add_compile_options(-Wno-unused-command-line-argument)
  endif()

  check_c_compiler_flag(-Wno-format-truncation CC_SUPPORTS_NO_FORMAT_TRUNCATION)
  if(CC_SUPPORTS_NO_FORMAT_TRUNCATION)
    add_compile_options(-Wno-format-truncation)
  else()
    message(STATUS "Compiler does not support -Wno-format-truncation")
  endif()

  check_c_compiler_flag(-Wstringop-truncation CC_STRINGOP_TRUNCATION)
  if(CC_STRINGOP_TRUNCATION)
    add_compile_options(-Wno-stringop-truncation)
  else()
    message(STATUS "Compiler does not support -Wno-stringop-truncation")
  endif()

  check_c_compiler_flag(-Wimplicit-fallthrough CC_SUPPORTS_IMPLICIT_FALLTHROUGH)
  if(CC_SUPPORTS_IMPLICIT_FALLTHROUGH)
    add_compile_options(-Wimplicit-fallthrough)
  else()
    message(STATUS "Compiler does not support -Wimplicit-fallthrough")
  endif()

  check_c_compiler_flag(-Wnewline-eof CC_SUPPORTS_NEWLINE_EOF)
  if(CC_SUPPORTS_NEWLINE_EOF)
    add_compile_options(-Wnewline-eof)
  endif()

  # strict overflow check produces false positives on gcc < 8
  if(CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_LESS 8)
    add_compile_options(-Wno-strict-overflow)
  endif()

  # -Wclobbered produces false positives on gcc < 9
  if(CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_LESS 9)
    add_compile_options(-Wno-clobbered)
  endif()

  if(CMAKE_COMPILER_IS_GNUCC)
    add_compile_options(
      # Seems to be broken in GCC 11 with designated initializers.
      -Wno-missing-field-initializers)
  endif()

  # On UNIX, the compiler needs to support -fvisibility=hidden to hide symbols
  # by default
  check_c_compiler_flag(-fvisibility=hidden CC_SUPPORTS_VISIBILITY_HIDDEN)

  if(NOT CC_SUPPORTS_VISIBILITY_HIDDEN)
    message(
      FATAL_ERROR
        "The compiler ${CMAKE_C_COMPILER_ID} does not support -fvisibility=hidden"
    )
  endif(NOT CC_SUPPORTS_VISIBILITY_HIDDEN)
endif()

# On Windows, default to only include Release builds so MSBuild.exe 'just works'
if(WIN32 AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_CONFIGURATION_TYPES
      Release
      CACHE
        STRING
        "Semicolon separated list of supported configuration types, only supports Debug, Release, MinSizeRel, and RelWithDebInfo, anything else will be ignored."
        FORCE)
endif()

message(STATUS "Using compiler ${CMAKE_C_COMPILER_ID}")

if(ENABLE_OPTIMIZER_DEBUG)
  message(
    STATUS
      "Enabling OPTIMIZER_DEBUG. Make sure that ${PG_SOURCE_DIR} is installed and built with OPTIMIZER_DEBUG."
  )
  add_definitions(-DOPTIMIZER_DEBUG)
endif()

# Search paths for Postgres binaries
if(WIN32)
  find_path(
    PG_PATH postgres.exe
    PATHS "C:/PostgreSQL" "C:/Program Files/PostgreSQL"
    PATH_SUFFIXES bin 14/bin 15/bin 16/bin
    DOC "The path to a PostgreSQL installation")
elseif(UNIX)
  find_path(
    PG_PATH postgres
    PATHS $ENV{HOME} /opt/local/pgsql /usr/local/pgsql /usr/lib/postgresql
    PATH_SUFFIXES bin 14/bin 15/bin 16/bin
    DOC "The path to a PostgreSQL installation")
endif()

find_program(
  PG_CONFIG pg_config
  HINTS ${PG_PATH}
  PATH_SUFFIXES bin
  DOC "The path to the pg_config of the PostgreSQL version to compile against")

if(NOT PG_CONFIG)
  message(FATAL_ERROR "Unable to find 'pg_config'")
endif()

find_package(Git)

# Check PostgreSQL version
execute_process(
  COMMAND ${PG_CONFIG} --version
  OUTPUT_VARIABLE PG_VERSION_STRING
  OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT ${PG_VERSION_STRING} MATCHES
   "^PostgreSQL[ ]+([0-9]+)(\\.([0-9]+)|beta|devel|rc[0-9]+)")
  message(FATAL_ERROR "Could not parse PostgreSQL version ${PG_VERSION_STRING}")
endif()

set(PG_VERSION_MAJOR ${CMAKE_MATCH_1})
if(${CMAKE_MATCH_COUNT} GREATER "2")
  set(PG_VERSION_MINOR ${CMAKE_MATCH_3})
else()
  set(PG_VERSION_MINOR 0)
endif()
set(PG_VERSION "${PG_VERSION_MAJOR}.${PG_VERSION_MINOR}")

message(
  STATUS
    "Compiling against PostgreSQL version ${PG_VERSION} using pg_config '${PG_CONFIG}'"
)

# Ensure that PostgreSQL version is supported and consistent with src/compat.h
# version check
if((${PG_VERSION_MAJOR} LESS "14")
   OR (${PG_VERSION_MAJOR} GREATER "16")
   AND NOT (${EXPERIMENTAL}))
  message(FATAL_ERROR "TimescaleDB only supports PostgreSQL 14, 15 and 16")
endif()

# Get PostgreSQL configuration from pg_config
get_pg_config(PG_INCLUDEDIR --includedir)
get_pg_config(PG_INCLUDEDIR_SERVER --includedir-server)
get_pg_config(PG_LIBDIR --libdir)
get_pg_config(PG_PKGLIBDIR --pkglibdir)
get_pg_config(PG_SHAREDIR --sharedir)
get_pg_config(PG_BINDIR --bindir)
get_pg_config(PG_CFLAGS --cflags)
get_pg_config(PG_CFLAGS_SL --cflags_sl)
get_pg_config(PG_CPPFLAGS --cppflags)
get_pg_config(PG_LDFLAGS --ldflags)
get_pg_config(PG_LIBS --libs)

separate_arguments(PG_CFLAGS)
foreach(option ${PG_CFLAGS})

=== sql/CMakeLists.txt ===
--- 
+++ 
@@ -9,15 +9,6 @@
 # There still needs to be an entry here to build an update script for that
 # version. Thus, for every new release, an entry should be added here.
 set(MOD_FILES
-    updates/2.1.0--2.1.1.sql
-    updates/2.1.1--2.2.0.sql
-    updates/2.2.0--2.2.1.sql
-    updates/2.2.1--2.3.0.sql
-    updates/2.3.0--2.3.1.sql
-    updates/2.3.1--2.4.0.sql
-    updates/2.4.0--2.4.1.sql
-    updates/2.4.1--2.4.2.sql
-    updates/2.4.2--2.5.0.sql
     updates/2.5.0--2.5.1.sql
     updates/2.5.1--2.5.2.sql
     updates/2.5.2--2.6.0.sql
@@ -48,20 +39,18 @@
     updates/2.14.1--2.14.2.sql
     updates/2.14.2--2.15.0.sql
     updates/2.15.0--2.15.1.sql
-    updates/2.15.1--2.15.2.sql)
+    updates/2.15.1--2.15.2.sql
+    updates/2.15.2--2.15.3.sql
+    updates/2.15.3--2.16.0.sql
+    updates/2.16.0--2.16.1.sql)
 
 # The downgrade file to generate a downgrade script for the current version, as
 # specified in version.config
-set(CURRENT_REV_FILE 2.15.2--2.15.1.sql)
+set(CURRENT_REV_FILE 2.16.1--2.16.0.sql)
 # Files for generating old downgrade scripts. This should only include files for
 # downgrade from one version to its previous version since we do not support
 # skipping versions when downgrading.
 set(OLD_REV_FILES
-    2.3.1--2.3.0.sql
-    2.4.0--2.3.1.sql
-    2.4.1--2.4.0.sql
-    2.4.2--2.4.1.sql
-    2.5.0--2.4.2.sql
     2.5.1--2.5.0.sql
     2.5.2--2.5.1.sql
     2.6.0--2.5.2.sql
@@ -92,7 +81,10 @@
     2.14.2--2.14.1.sql
     2.15.0--2.14.2.sql
     2.15.1--2.15.0.sql
-    2.15.2--2.15.1.sql)
+    2.15.2--2.15.1.sql
+    2.15.3--2.15.2.sql
+    2.16.0--2.15.3.sql
+    2.16.1--2.16.0.sql)
 
 set(MODULE_PATHNAME "$libdir/timescaledb-${PROJECT_VERSION_MOD}")
 set(LOADER_PATHNAME "$libdir/timescaledb")

=== test/pgtest/CMakeLists.txt ===
set(PG_REGRESS_DIR
    ${PG_SOURCE_DIR}/src/test/regress
    CACHE PATH "Path to PostgreSQL's regress directory")

# input and output directory got removed in PG15
set(PGTEST_DIRS ${PG_REGRESS_DIR}/data ${PG_REGRESS_DIR}/sql
                ${PG_REGRESS_DIR}/expected)
if(EXISTS ${PG_REGRESS_DIR}/input AND EXISTS ${PG_REGRESS_DIR}/output)
  list(APPEND PGTEST_DIRS ${PG_REGRESS_DIR}/input ${PG_REGRESS_DIR}/output)
endif()

# Copy the input and output files from PostgreSQL's test suite. The test suite
# generates some SQL scripts and output files from template source files and
# require directories to be colocated
file(COPY ${PGTEST_DIRS} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

file(READ ${PG_REGRESS_DIR}/parallel_schedule PG_TEST_SCHEDULE)

# create directory for tablespace test
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testtablespace)

# Tests to ignore
set(PG_IGNORE_TESTS database event_trigger opr_sanity sanity_check type_sanity)

# Modify the test schedule to ignore some tests
foreach(IGNORE_TEST ${PG_IGNORE_TESTS})
  # ignored schedules was removed in PG16
  # https://github.com/postgres/postgres/commit/bd8d453e9b5f8b632a400a9e796fc041aed76d82
  if(${PG_VERSION_MAJOR} LESS "16")
    string(CONCAT PG_TEST_SCHEDULE "ignore: ${IGNORE_TEST}\n"
                  ${PG_TEST_SCHEDULE})
  else()
    # remove the ignored test from the schedule
    string(REPLACE "test: ${IGNORE_TEST}\n" "" PG_TEST_SCHEDULE
                   "${PG_TEST_SCHEDULE}")
    string(REPLACE " ${IGNORE_TEST} " " " PG_TEST_SCHEDULE
                   "${PG_TEST_SCHEDULE}")
    string(REPLACE " ${IGNORE_TEST}\n" "\n" PG_TEST_SCHEDULE
                   "${PG_TEST_SCHEDULE}")
  endif()
endforeach(IGNORE_TEST)

# Write the final test schedule
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/schedule ${PG_TEST_SCHEDULE})

# Need --dlpath set to PostgreSQL's test directory so that the tests can load
# libraries there
set(PG_REGRESS_OPTS_PGTEST
    --schedule=${CMAKE_CURRENT_BINARY_DIR}/schedule
    --load-extension=timescaledb --dlpath=${PG_REGRESS_DIR})

add_custom_target(
  pginstallcheck
  COMMAND ${PG_REGRESS} ${PG_REGRESS_OPTS_BASE} ${PG_REGRESS_OPTS_PGTEST}
          ${PG_REGRESS_OPTS_TEMP_INSTANCE_PGTEST}
  USES_TERMINAL)

add_custom_target(
  pginstallchecklocal
  COMMAND ${PG_REGRESS} ${PG_REGRESS_OPTS_BASE} ${PG_REGRESS_OPTS_PGTEST}
          ${PG_REGRESS_OPTS_LOCAL_INSTANCE}
  USES_TERMINAL)

=== test/sql/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,11 @@
     constraint.sql
     copy.sql
     copy_where.sql
+    cursor.sql
+    ddl.sql
     ddl_errors.sql
+    ddl_extra.sql
+    delete.sql
     debug_utils.sql
     drop_extension.sql
     drop_hypertable.sql
@@ -49,23 +53,22 @@
     tablespace.sql
     triggers.sql
     truncate.sql
+    trusted_extension.sql
+    update.sql
     upsert.sql
     util.sql
     vacuum.sql
+    vacuum_parallel.sql
     version.sql
     license.sql)
 
 set(TEST_TEMPLATES
     append.sql.in
     cluster.sql.in
-    cursor.sql.in
-    ddl.sql.in
-    delete.sql.in
     histogram_test.sql.in
     insert.sql.in
     plan_hashagg.sql.in
     rowsecurity.sql.in
-    update.sql.in
     parallel.sql.in
     partitionwise.sql.in
     plan_expand_hypertable.sql.in
@@ -114,25 +117,15 @@
   endif()
 endif(CMAKE_BUILD_TYPE MATCHES Debug)
 
-if((${PG_VERSION_MAJOR} GREATER_EQUAL "13"))
-  list(APPEND TEST_FILES trusted_extension.sql vacuum_parallel.sql)
-endif()
-
-if((${PG_VERSION_MAJOR} GREATER_EQUAL "14"))
-  list(APPEND TEST_FILES ddl_extra.sql)
-endif()
-
 if((${PG_VERSION_MAJOR} GREATER_EQUAL "15"))
   list(APPEND TEST_FILES merge.sql)
   list(APPEND TEST_TEMPLATES ts_merge.sql.in)
 endif()
 
-# pg_dump_unprivileged.sql was fixed by an upstream change to pg_dump in 13.14,
-# 14.11, 15.6, and 16.2
-if(((${PG_VERSION_MAJOR} EQUAL "13") AND (${PG_VERSION_MINOR} GREATER_EQUAL "14"
+# pg_dump_unprivileged.sql was fixed by an upstream change to pg_dump in 14.11,
+# 15.6, and 16.2
+if(((${PG_VERSION_MAJOR} EQUAL "14") AND (${PG_VERSION_MINOR} GREATER_EQUAL "11"
                                          ))
-   OR ((${PG_VERSION_MAJOR} EQUAL "14") AND (${PG_VERSION_MINOR} GREATER_EQUAL
-                                             "11"))
    OR ((${PG_VERSION_MAJOR} EQUAL "15") AND (${PG_VERSION_MINOR} GREATER_EQUAL
                                              "6"))
    OR ((${PG_VERSION_MAJOR} EQUAL "16") AND (${PG_VERSION_MINOR} GREATER_EQUAL

=== test/src/bgw/CMakeLists.txt ===
set(SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/log.c
    ${CMAKE_CURRENT_SOURCE_DIR}/timer_mock.c
    ${CMAKE_CURRENT_SOURCE_DIR}/scheduler_mock.c
    ${CMAKE_CURRENT_SOURCE_DIR}/params.c
    ${CMAKE_CURRENT_SOURCE_DIR}/test_job_refresh.c)

target_sources(${TESTS_LIB_NAME} PRIVATE ${SOURCES})

=== debian/changelog ===
timescaledb (2.16.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.16.1+dfsg.

 -- Christoph Berg <myon@debian.org>  Wed, 07 Aug 2024 11:37:48 +0200

=== debian/control ===
Source: timescaledb
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 architecture-is-64-bit,
 architecture-is-little-endian,
 cmake,
 debhelper-compat (= 13),
 postgresql-all (>= 217~),
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/timescale/timescaledb
Vcs-Browser: https://salsa.debian.org/postgresql/timescaledb
Vcs-Git: https://salsa.debian.org/postgresql/timescaledb.git

Package: postgresql-16-timescaledb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
Description: time-series SQL database optimized for fast ingest and complex queries
 TimescaleDB is an open-source database designed to make SQL scalable for
 time-series data. It is engineered up from PostgreSQL and packaged as a
 PostgreSQL extension, providing automatic partitioning across time and space
 (partitioning key), as well as full SQL support.
 .
 This package contains the Apache-licensed version of timescaledb.

## timescaledb 2.17.0+dfsg

=== sql/CMakeLists.txt ===
--- 
+++ 
@@ -42,11 +42,12 @@
     updates/2.15.1--2.15.2.sql
     updates/2.15.2--2.15.3.sql
     updates/2.15.3--2.16.0.sql
-    updates/2.16.0--2.16.1.sql)
+    updates/2.16.0--2.16.1.sql
+    updates/2.16.1--2.17.0.sql)
 
 # The downgrade file to generate a downgrade script for the current version, as
 # specified in version.config
-set(CURRENT_REV_FILE 2.16.1--2.16.0.sql)
+set(CURRENT_REV_FILE 2.17.0--2.16.1.sql)
 # Files for generating old downgrade scripts. This should only include files for
 # downgrade from one version to its previous version since we do not support
 # skipping versions when downgrading.
@@ -84,7 +85,8 @@
     2.15.2--2.15.1.sql
     2.15.3--2.15.2.sql
     2.16.0--2.15.3.sql
-    2.16.1--2.16.0.sql)
+    2.16.1--2.16.0.sql
+    2.17.0--2.16.1.sql)
 
 set(MODULE_PATHNAME "$libdir/timescaledb-${PROJECT_VERSION_MOD}")
 set(LOADER_PATHNAME "$libdir/timescaledb")

=== debian/changelog ===
timescaledb (2.17.0+dfsg-2) unstable; urgency=medium

  * Extend histogram-test patch to PG17.

 -- Christoph Berg <myon@debian.org>  Tue, 15 Oct 2024 14:31:45 +0200

timescaledb (2.17.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.17.0+dfsg.
  * Upload for PostgreSQL 17.
  * Mark postgresql-all as <!nocheck>.

 -- Christoph Berg <myon@debian.org>  Tue, 15 Oct 2024 13:36:50 +0200

## timescaledb 2.17.1+dfsg

=== sql/CMakeLists.txt ===
--- 
+++ 
@@ -43,11 +43,12 @@
     updates/2.15.2--2.15.3.sql
     updates/2.15.3--2.16.0.sql
     updates/2.16.0--2.16.1.sql
-    updates/2.16.1--2.17.0.sql)
+    updates/2.16.1--2.17.0.sql
+    updates/2.17.0--2.17.1.sql)
 
 # The downgrade file to generate a downgrade script for the current version, as
 # specified in version.config
-set(CURRENT_REV_FILE 2.17.0--2.16.1.sql)
+set(CURRENT_REV_FILE 2.17.1--2.17.0.sql)
 # Files for generating old downgrade scripts. This should only include files for
 # downgrade from one version to its previous version since we do not support
 # skipping versions when downgrading.
@@ -86,7 +87,8 @@
     2.15.3--2.15.2.sql
     2.16.0--2.15.3.sql
     2.16.1--2.16.0.sql
-    2.17.0--2.16.1.sql)
+    2.17.0--2.16.1.sql
+    2.17.1--2.17.0.sql)
 
 set(MODULE_PATHNAME "$libdir/timescaledb-${PROJECT_VERSION_MOD}")
 set(LOADER_PATHNAME "$libdir/timescaledb")

=== debian/changelog ===
timescaledb (2.17.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.17.1+dfsg.

 -- Christoph Berg <myon@debian.org>  Sun, 27 Oct 2024 14:07:21 +0100

## timescaledb 2.17.2+dfsg

=== sql/CMakeLists.txt ===
--- 
+++ 
@@ -44,11 +44,12 @@
     updates/2.15.3--2.16.0.sql
     updates/2.16.0--2.16.1.sql
     updates/2.16.1--2.17.0.sql
-    updates/2.17.0--2.17.1.sql)
+    updates/2.17.0--2.17.1.sql
+    updates/2.17.1--2.17.2.sql)
 
 # The downgrade file to generate a downgrade script for the current version, as
 # specified in version.config
-set(CURRENT_REV_FILE 2.17.1--2.17.0.sql)
+set(CURRENT_REV_FILE 2.17.2--2.17.1.sql)
 # Files for generating old downgrade scripts. This should only include files for
 # downgrade from one version to its previous version since we do not support
 # skipping versions when downgrading.
@@ -88,7 +89,8 @@
     2.16.0--2.15.3.sql
     2.16.1--2.16.0.sql
     2.17.0--2.16.1.sql
-    2.17.1--2.17.0.sql)
+    2.17.1--2.17.0.sql
+    2.17.2--2.17.1.sql)
 
 set(MODULE_PATHNAME "$libdir/timescaledb-${PROJECT_VERSION_MOD}")
 set(LOADER_PATHNAME "$libdir/timescaledb")

=== test/pgtest/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,8 @@
 file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testtablespace)
 
 # Tests to ignore
-set(PG_IGNORE_TESTS database event_trigger opr_sanity sanity_check type_sanity)
+set(PG_IGNORE_TESTS database event_trigger jsonb_jsonpath opr_sanity
+                    sanity_check type_sanity)
 
 # Modify the test schedule to ignore some tests
 foreach(IGNORE_TEST ${PG_IGNORE_TESTS})

=== debian/changelog ===
timescaledb (2.17.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2.17.2+dfsg.

 -- Christoph Berg <myon@debian.org>  Thu, 07 Nov 2024 12:55:19 +0100

## timescaledb 2.18.0+dfsg

=== sql/CMakeLists.txt ===
--- 
+++ 
@@ -45,11 +45,12 @@
     updates/2.16.0--2.16.1.sql
     updates/2.16.1--2.17.0.sql
     updates/2.17.0--2.17.1.sql
-    updates/2.17.1--2.17.2.sql)
+    updates/2.17.1--2.17.2.sql
+    updates/2.17.2--2.18.0.sql)
 
 # The downgrade file to generate a downgrade script for the current version, as
 # specified in version.config
-set(CURRENT_REV_FILE 2.17.2--2.17.1.sql)
+set(CURRENT_REV_FILE 2.18.0--2.17.2.sql)
 # Files for generating old downgrade scripts. This should only include files for
 # downgrade from one version to its previous version since we do not support
 # skipping versions when downgrading.
@@ -90,7 +91,8 @@
     2.16.1--2.16.0.sql
     2.17.0--2.16.1.sql
     2.17.1--2.17.0.sql
-    2.17.2--2.17.1.sql)
+    2.17.2--2.17.1.sql
+    2.18.0--2.17.2.sql)
 
 set(MODULE_PATHNAME "$libdir/timescaledb-${PROJECT_VERSION_MOD}")
 set(LOADER_PATHNAME "$libdir/timescaledb")

=== debian/changelog ===
timescaledb (2.18.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.18.0+dfsg.

 -- Christoph Berg <myon@debian.org>  Tue, 28 Jan 2025 20:50:09 +0100

## timescaledb 2.18.1+dfsg

=== sql/CMakeLists.txt ===
--- 
+++ 
@@ -46,11 +46,12 @@
     updates/2.16.1--2.17.0.sql
     updates/2.17.0--2.17.1.sql
     updates/2.17.1--2.17.2.sql
-    updates/2.17.2--2.18.0.sql)
+    updates/2.17.2--2.18.0.sql
+    updates/2.18.0--2.18.1.sql)
 
 # The downgrade file to generate a downgrade script for the current version, as
 # specified in version.config
-set(CURRENT_REV_FILE 2.18.0--2.17.2.sql)
+set(CURRENT_REV_FILE 2.18.1--2.18.0.sql)
 # Files for generating old downgrade scripts. This should only include files for
 # downgrade from one version to its previous version since we do not support
 # skipping versions when downgrading.
@@ -92,7 +93,8 @@
     2.17.0--2.16.1.sql
     2.17.1--2.17.0.sql
     2.17.2--2.17.1.sql
-    2.18.0--2.17.2.sql)
+    2.18.0--2.17.2.sql
+    2.18.1--2.18.0.sql)
 
 set(MODULE_PATHNAME "$libdir/timescaledb-${PROJECT_VERSION_MOD}")
 set(LOADER_PATHNAME "$libdir/timescaledb")

=== test/sql/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,6 @@
 include(GenerateTestSchedule)
 
 set(TEST_FILES
-    agg_bookends.sql
     alter.sql
     alternate_users.sql
     baserel_cache.sql
@@ -9,6 +8,7 @@
     chunks.sql
     chunk_adaptive.sql
     chunk_utils.sql
+    cluster.sql
     create_chunks.sql
     create_hypertable.sql
     create_table.sql
@@ -19,17 +19,15 @@
     ddl.sql
     ddl_errors.sql
     ddl_extra.sql
+    debug_utils.sql
     delete.sql
-    debug_utils.sql
     drop_extension.sql
     drop_hypertable.sql
-    drop_owned.sql
     drop_rename_hypertable.sql
     drop_schema.sql
     dump_meta.sql
     extension_scripts.sql
     generated_as_identity.sql
-    grant_hypertable.sql
     hash.sql
     index.sql
     information_views.sql
@@ -37,7 +35,6 @@
     insert_single.sql
     insert_returning.sql
     lateral.sql
-    null_exclusion.sql
     partition.sql
     partitioning.sql
     pg_join.sql
@@ -63,10 +60,13 @@
     license.sql)
 
 set(TEST_TEMPLATES
+    agg_bookends.sql.in
     append.sql.in
-    cluster.sql.in
+    drop_owned.sql.in
+    grant_hypertable.sql.in
     histogram_test.sql.in
     insert.sql.in
+    null_exclusion.sql.in
     plan_hashagg.sql.in
     rowsecurity.sql.in
     parallel.sql.in
@@ -118,7 +118,7 @@
 endif(CMAKE_BUILD_TYPE MATCHES Debug)
 
 if((${PG_VERSION_MAJOR} GREATER_EQUAL "15"))
-  list(APPEND TEST_FILES merge.sql)
+  list(APPEND TEST_FILES merge.sql tableam_alter.sql)
   list(APPEND TEST_TEMPLATES ts_merge.sql.in)
 endif()

=== debian/changelog ===
timescaledb (2.18.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2.18.1+dfsg.

 -- Christoph Berg <myon@debian.org>  Mon, 10 Feb 2025 20:48:45 +0100

## timescaledb 2.18.2%2Bdfsg

=== debian/changelog ===
timescaledb (2.18.2+dfsg-1.pgdg110+1) bullseye-pgdg; urgency=medium

  * Rebuild for bullseye-pgdg.
  * Changes applied by generate-pgdg-source:
    + Remove tzdata-legacy from build and test dependencies.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Wed, 19 Feb 2025 14:50:19 +0100

timescaledb (2.18.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2.18.2+dfsg.

 -- Christoph Berg <myon@debian.org>  Wed, 19 Feb 2025 14:50:19 +0100

## timescaledb 2.18.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,7 @@
   # Only call pg_config if the variable didn't already have a value.
   if(NOT ${var})
     execute_process(
-      COMMAND ${PG_CONFIG} ${ARGN}
+      COMMAND ${CMAKE_COMMAND} -E env LC_MESSAGES=C ${PG_CONFIG} ${ARGN}
       OUTPUT_VARIABLE _temp
       OUTPUT_STRIP_TRAILING_WHITESPACE)
   endif()
@@ -350,9 +350,9 @@
 # Ensure that PostgreSQL version is supported and consistent with src/compat.h
 # version check
 if((${PG_VERSION_MAJOR} LESS "14")
-   OR (${PG_VERSION_MAJOR} GREATER "16")
+   OR (${PG_VERSION_MAJOR} GREATER "17")
    AND NOT (${EXPERIMENTAL}))
-  message(FATAL_ERROR "TimescaleDB only supports PostgreSQL 14, 15 and 16")
+  message(FATAL_ERROR "TimescaleDB only supports PostgreSQL 14, 15, 16 and 17")
 endif()
 
 # Get PostgreSQL configuration from pg_config
@@ -369,4 +369,3 @@
 get_pg_config(PG_LIBS --libs)
 
 separate_arguments(PG_CFLAGS)
-foreach(option ${PG_CFLAGS})

=== sql/CMakeLists.txt ===
--- 
+++ 
@@ -47,11 +47,12 @@
     updates/2.17.0--2.17.1.sql
     updates/2.17.1--2.17.2.sql
     updates/2.17.2--2.18.0.sql
-    updates/2.18.0--2.18.1.sql)
+    updates/2.18.0--2.18.1.sql
+    updates/2.18.1--2.18.2.sql)
 
 # The downgrade file to generate a downgrade script for the current version, as
 # specified in version.config
-set(CURRENT_REV_FILE 2.18.1--2.18.0.sql)
+set(CURRENT_REV_FILE 2.18.2--2.18.1.sql)
 # Files for generating old downgrade scripts. This should only include files for
 # downgrade from one version to its previous version since we do not support
 # skipping versions when downgrading.
@@ -94,7 +95,8 @@
     2.17.1--2.17.0.sql
     2.17.2--2.17.1.sql
     2.18.0--2.17.2.sql
-    2.18.1--2.18.0.sql)
+    2.18.1--2.18.0.sql
+    2.18.2--2.18.1.sql)
 
 set(MODULE_PATHNAME "$libdir/timescaledb-${PROJECT_VERSION_MOD}")
 set(LOADER_PATHNAME "$libdir/timescaledb")

=== src/planner/CMakeLists.txt ===
set(SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/planner.c
    ${CMAKE_CURRENT_SOURCE_DIR}/add_hashagg.c
    ${CMAKE_CURRENT_SOURCE_DIR}/agg_bookend.c
    ${CMAKE_CURRENT_SOURCE_DIR}/constify_now.c
    ${CMAKE_CURRENT_SOURCE_DIR}/constraint_cleanup.c
    ${CMAKE_CURRENT_SOURCE_DIR}/expand_hypertable.c
    ${CMAKE_CURRENT_SOURCE_DIR}/partialize.c
    ${CMAKE_CURRENT_SOURCE_DIR}/space_constraint.c)
target_sources(${PROJECT_NAME} PRIVATE ${SOURCES})
